Subject: Re: [PATCH net-next 3/4] vxlan: remove gro_cell support

From: Paolo Abeni <[email-masked]>
Date: Fri, 08 Jul 2016 11:06:25 +0200

On Thu, 2016-07-07 at 18:13 +0200, Eric Dumazet wrote:
> On Thu, 2016-07-07 at 17:58 +0200, Paolo Abeni wrote:
> > GRO is now handled entirely by the udp_offload layer and  there is no need
> > for trying it again at the device level. We can drop gro_cell usage,
> > simplifying the driver a bit, while maintaining the same performance for
> > TCP and improving slightly for UDP.
> > This basically reverts the commit 58ce31cca1ff ("vxlan: GRO support
> > at tunnel layer")
> 
> Note that gro_cells provide GRO support after RPS, so this helps when we
> must perform TCP checksum computation, if NIC lacks CHECKSUM_COMPLETE
> 
> (Say we receive packets all steered to a single RX queue due to RSS hash
> being computed on outer header only)

You can still allow steering to multiple queues configuring an rx flow
hash computed on the outer l3 and l4 headers for udp, if supported by
your nic.

> Some people disable GRO on the physical device, but enable GRO on the
> tunnels.

I see. I'll resubmit only the first two patches. Allowing GRO on ingress
nic even for zero udp tunnel is still beneficial.

Paolo